#include <random>
#include <vector>
#include <iostream>

#include <SFML/Graphics.hpp>

#include "grid.h"
#include "person.h"
#include "robot.h"

int main() {
    // Create the main window
    #ifdef DRAW
    sf::RenderWindow app(sf::VideoMode(WIDTH * SIZE, HEIGHT * SIZE), "SFML window");
    #endif
    sf::Image img;
    img.loadFromFile("plan.png");
    int robotX, robotY;

    #ifndef DRAW
    srand(0);
    const int w = 0;
    for (int a = 0; a <= 100; srand(++a)) {
    #else
    const int w = 21;
    #endif
        Grid grid(img, robotX, robotY);
        Robot robot(grid, robotX, robotY, w);
        Robot robot2(grid, robotX, robotY, 0);

        // Start the game loop
        #ifndef DRAW
        unsigned int count = 0;
        while (true) {
        #else
        sf::Clock clock;
        while (app.isOpen()) {
            // Process events
            sf::Event event;
            while (app.pollEvent(event)) {
                // Close window : exit
                if (event.type == sf::Event::Closed)
                    app.close();
                if (event.type == sf::Event::KeyReleased && event.key.code == sf::Keyboard::C) {
                    robot.reset();
                    robot2.reset();
                }
            }

            if (sf::Mouse::isButtonPressed(sf::Mouse::Left)) {
                robot.setTarget(sf::Mouse::getPosition(app).x / SIZE, sf::Mouse::getPosition(app).y / SIZE);
                robot2.setTarget(sf::Mouse::getPosition(app).x / SIZE, sf::Mouse::getPosition(app).y / SIZE);
            }
            if (sf::Keyboard::isKeyPressed(sf::Keyboard::F) || clock.getElapsedTime().asMilliseconds() > 1000.f / 10.f) {
                clock.restart();
                #endif
                #ifndef DRAW
                ++count;
                try {
                #endif
                    robot.step();
                    robot2.step();
                #ifndef DRAW
                } catch (unsigned int e) {
                    std::cout << w << ' ' << e << ' ' << count << std::endl;
                    goto end;
                }
                #endif
                grid.step();
                #ifdef DRAW
            }

            // Clear screen
            app.clear();

            grid.draw(app);
            robot.draw(app);
            robot2.draw(app);

            // Update the window
            app.display();
            #endif
        }
        #ifndef DRAW
        end:;
    }
    #endif

    return EXIT_SUCCESS;
}
