#ifndef PERSON_H_INCLUDED
#define PERSON_H_INCLUDED

#include <stack>
#include <random>

class Grid;

class Person {
public:
    Person(Grid& grid, const int& x, const int& y);
    ~Person();
    bool step();
    bool isPos(const int& pX, const int& pY) const {
        return x == pX && y == pY;
    }
private:
    static std::poisson_distribution<unsigned int> poisson;

    Grid& grid;
    int x, y;
    float directionX, directionY;
    std::stack<std::pair<int, int>> target;
    std::stack<int> path;
};

#endif // PERSON_H_INCLUDED
