#ifndef ROBOT_H_INCLUDED
#define ROBOT_H_INCLUDED

#include <stack>
#include <SFML/Graphics/RectangleShape.hpp>
#include <SFML/Graphics/Text.hpp>
namespace sf{class RenderWindow;}
class Grid;

class Robot {
public:
    Robot(Grid& grid, const int& x, const int& y, const float& weight);
    void step();
    void draw(sf::RenderWindow& window) const;
    void setTarget(const int& x, const int& y);
    void reset() {count = 0; text.setString("0");}
private:
    static sf::Font font;
    Grid& grid;
    int x, y;
    int targetX, targetY;
    char direction;
    const float weight;
    std::stack<int> path, vision;
    sf::RectangleShape shape;
    sf::Text text;
    unsigned int count = 0, targets = 0;

    void setVisible();
};

#endif // ROBOT_H_INCLUDED
